CVC4::SynchronizedSharedChannel< T > Class Template Referenceabstract

`#include <channel.h>`

Inheritance diagram for CVC4::SynchronizedSharedChannel< T >:
[legend]
Collaboration diagram for CVC4::SynchronizedSharedChannel< T >:
[legend]

## Public Types

typedef boost::circular_buffer< T > | container_type
typedef container_type::size_type | size_type
typedef container_type::value_type | value_type
typedef boost::call_traits< value_type >::param_type | param_type

## Public Member Functions

| SynchronizedSharedChannel (size_type capacity)
bool | push (param_type item)
value_type | pop ()
bool | empty ()
bool | full ()
virtual bool | push (const T &)=0

## Detailed Description

template<typename T>
class CVC4::SynchronizedSharedChannel< T >

Definition at line 63 of file channel.h.

## Member Typedef Documentation

## container_type

template<typename T >

typedef boost::circular_buffer<T> CVC4::SynchronizedSharedChannel< T >::container_type

Definition at line 65 of file channel.h.

## param_type

template<typename T >

typedef boost::call_traits<value_type>::param_type CVC4::SynchronizedSharedChannel< T >::param_type

Definition at line 68 of file channel.h.

## size_type

template<typename T >

typedef container_type::size_type CVC4::SynchronizedSharedChannel< T >::size_type

Definition at line 66 of file channel.h.

## value_type

template<typename T >

typedef container_type::value_type CVC4::SynchronizedSharedChannel< T >::value_type

Definition at line 67 of file channel.h.

## Constructor & Destructor Documentation

## SynchronizedSharedChannel()

template<typename T >

CVC4::SynchronizedSharedChannel< T >::SynchronizedSharedChannel | ( | size_type | capacity | ) |

inlineexplicit

Definition at line 70 of file channel.h.

## Member Function Documentation

## empty()

template<typename T >

bool CVC4::SynchronizedSharedChannel< T >::empty | ( |  | ) |

inlinevirtual

Implements CVC4::SharedChannel< T >.

Definition at line 95 of file channel.h.

## full()

template<typename T >

bool CVC4::SynchronizedSharedChannel< T >::full | ( |  | ) |

inlinevirtual

Implements CVC4::SharedChannel< T >.

Definition at line 96 of file channel.h.

## pop()

template<typename T >

value_type CVC4::SynchronizedSharedChannel< T >::pop | ( |  | ) |

inlinevirtual

Implements CVC4::SharedChannel< T >.

Definition at line 84 of file channel.h.

## push() [1/2]

template<typename T >

virtual bool CVC4::SharedChannel< T >::push | ( | const T & |  | ) |

pure virtualinherited

## push() [2/2]

template<typename T >

bool CVC4::SynchronizedSharedChannel< T >::push | ( | param_type | item | ) |

inline

Definition at line 72 of file channel.h.

The documentation for this class was generated from the following file:

- src/util/channel.h